//---------------------------------------------------------------------------
#ifndef Moa_ClipboardH
#define Moa_ClipboardH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Moa_window { class TMessageWindow; } using namespace Moa_window;
//---------------------------------------------------------------------------
namespace Moa_clipboard {
//---------------------------------------------------------------------------
class EClipboardError : public Exception
{
public:
	__fastcall EClipboardError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TClipboardWatcher : public TObject
{
private:
	TMessageWindow* FMessageWindow;
	HWND FNextHandle;
	bool FEnabled;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall MessageWindowMessage(TObject* ASender, TMessage& AMessage, bool& AHandled);
	void __fastcall WMChangeCbChain(TMessage& AMessage);
	void __fastcall WMDrawClipboard(TMessage& AMessage);
	void __fastcall DoChange();
	void __fastcall SetEnabled(bool AEnabled);
	__property TMessageWindow* MessageWindow = {read=FMessageWindow};
	__property HWND NextHandle = {read=FNextHandle};
protected:
public:
	__fastcall TClipboardWatcher();
	virtual __fastcall ~TClipboardWatcher();
	__property bool Enabled = {read=FEnabled, write=SetEnabled};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
} // End Moa_clipboard
using namespace Moa_clipboard;
//---------------------------------------------------------------------------
#endif

