//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_IniFile.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_inifile {
//---------------------------------------------------------------------------
void __fastcall TIniSection::Initialize()
{
	try {
		FSubSectionList = new TStringList();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::Uninitialize()
{
	delete FSubSectionList;
	FSubSectionList = NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TIniSection::GetSection()
{
	AnsiString LSection;
	for(int LI = 0; LI < SubSectionList->Count; ++LI) {
		if(LI > 0) {
			LSection += SubSectionList->Delimiter;
		}
		LSection += SubSectionList->Strings[LI];
	}
	return LSection;
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::SetSection(const AnsiString& ASection)
{
	AnsiString LSection = ASection;
	AnsiString LSeparator = Separator;
	while(LSection.Length() > 0) {
		int LIndex = LSection.AnsiPos(LSeparator);
		if(LIndex < 1) {
			SubSectionList->Add(LSection);
			LSection.SetLength(0);
		}
		else {
			SubSectionList->Add(LSection.SubString(1, LIndex - 1));
			LSection.Delete(1, LIndex);
		}
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TIniSection::GetSubSection(int AIndex)
{
	return SubSectionList->Strings[AIndex];
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::SetSubSection(int AIndex, const AnsiString& ASubSection)
{
	SubSectionList->Strings[AIndex] = ASubSection;
}
//---------------------------------------------------------------------------
int __fastcall TIniSection::GetLevel()
{
	return SubSectionList->Count;
}
//---------------------------------------------------------------------------
char __fastcall TIniSection::GetSeparator()
{
	return SubSectionList->Delimiter;
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::SetSeparator(char ASeparator)
{
	SubSectionList->Delimiter = ASeparator;
}
//---------------------------------------------------------------------------
__fastcall TIniSection::TIniSection() :
	TObject(),
	FSubSectionList(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TIniSection::~TIniSection()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::Enter(const AnsiString& ASubSection)
{
	SubSectionList->Add(ASubSection);
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::Leave()
{
	SubSectionList->Delete(SubSectionList->Count - 1);
}
//---------------------------------------------------------------------------
void __fastcall TIniSection::Exit()
{
	SubSectionList->Clear();
}
//---------------------------------------------------------------------------
} // End namespace Moa_inifile
//---------------------------------------------------------------------------

