//---------------------------------------------------------------------------
#ifndef Moa_IniFileH
#define Moa_IniFileH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_inifile {
//---------------------------------------------------------------------------
class EIniFileError : public Exception
{
public:
	__fastcall EIniFileError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TIniSection : TObject
{
private:
	TStrings* FSubSectionList;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	AnsiString __fastcall GetSection();
	void __fastcall SetSection(const AnsiString& ASection);
	AnsiString __fastcall GetSubSection(int AIndex);
	void __fastcall SetSubSection(int AIndex, const AnsiString& ASubSection);
	int __fastcall GetLevel();
	char __fastcall GetSeparator();
	void __fastcall SetSeparator(char ASeparator);
	__property TStrings* SubSectionList = {read=FSubSectionList};
protected:
public:
	__fastcall TIniSection();
	virtual __fastcall ~TIniSection();
	void __fastcall Enter(const AnsiString& ASubSection);
	void __fastcall Leave();
	void __fastcall Exit();
	__property AnsiString Section = {read=GetSection, write=SetSection};
	__property AnsiString SubSections[int AIndex] = {read=GetSubSection, write=SetSubSection};
	__property int Level = {read=GetLevel};
	__property char Separator = {read=GetSeparator, write=SetSeparator};
};
//---------------------------------------------------------------------------
} // End namespace Moa_inifile
using namespace Moa_inifile;
//---------------------------------------------------------------------------
#endif

