//---------------------------------------------------------------------------
#ifndef Moa_ListH
#define Moa_ListH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_list {
//---------------------------------------------------------------------------
class TListHelper
{
private:
	TList* FValue;
	__fastcall TListHelper(const TListHelper& AOther); // Forbidden
	TListHelper& __fastcall operator =(const TListHelper& AOther); // Forbidden
protected:
public:
	__fastcall TListHelper(TList* AValue);
	virtual __fastcall ~TListHelper();
	virtual void __fastcall AddItems(TList* ASrcList);
	virtual void __fastcall SwapItems(TList* AList);
	virtual void* __fastcall PopFirst();
	virtual void* __fastcall PopLast();
	virtual void* __fastcall Pop(int AIndex);
	virtual void* __fastcall Swap(int AIndex, void* AItem);
	virtual void __fastcall Invert();
	virtual void __fastcall EnsureCapacity(int ACapacity);
	__property TList* Value = {read=FValue};
};
//---------------------------------------------------------------------------
class TObjectListHelper : public TListHelper
{
private:
	TObjectList* __fastcall GetValue();
protected:
public:
	__fastcall TObjectListHelper(TObjectList* AValue);
	virtual __fastcall ~TObjectListHelper();
	virtual HIDESBASE void __fastcall SwapItems(TObjectList* AList);
	virtual void __fastcall Clear(bool AFreeObjects);
	virtual HIDESBASE TObject* __fastcall PopFirst();
	virtual HIDESBASE TObject* __fastcall PopLast();
	virtual HIDESBASE TObject* __fastcall Pop(int AIndex);
	virtual HIDESBASE TObject* __fastcall Swap(int AIndex, TObject* AItem);
	__property TObjectList* Value = {read=GetValue};
};
//---------------------------------------------------------------------------
class TStringsHelper
{
private:
	TStrings* FValue;
	__fastcall TStringsHelper(const TStringsHelper& AOther); // Forbidden
	TStringsHelper& __fastcall operator =(const TStringsHelper& AOther); // Forbidden
protected:
public:
	__fastcall TStringsHelper(TStrings* AValue);
	virtual __fastcall ~TStringsHelper();
	virtual void __fastcall SwapItems(TStrings* AStrings);
	virtual AnsiString __fastcall PopFirst();
	virtual AnsiString __fastcall PopLast();
	virtual AnsiString __fastcall Pop(int AIndex);
	virtual AnsiString __fastcall Swap(int AIndex, const AnsiString& AString);
	virtual TObject* __fastcall SwapObject(int AIndex, TObject* AObject);
	virtual void __fastcall Invert();
	virtual int __fastcall Find(const AnsiString& AString);
	virtual int __fastcall FindObject(TObject* AObject);
	virtual void __fastcall EnsureCapacity(int ACapacity);
	__property TStrings* Value = {read=FValue};
};
//---------------------------------------------------------------------------
class TStringListHelper : public TStringsHelper
{
private:
	TStringList* __fastcall GetValue();
protected:
public:
	__fastcall TStringListHelper(TStringList* AValue);
	virtual __fastcall ~TStringListHelper();
	virtual bool __fastcall TryAdd(const AnsiString& AString);
	virtual int __fastcall Find(const AnsiString& AString);
	__property TStringList* Value = {read=GetValue};
};
//---------------------------------------------------------------------------
} // End namespace Moa_list
using namespace Moa_list;
//---------------------------------------------------------------------------
#endif

