//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_Net.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_net {
//---------------------------------------------------------------------------
const bool TUrlCoder::SafeCharTable[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1,
	0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
}; // 1: [0-9], [A-Z], [a-z], [$], [-], [_], [.], [+], [!], [*], ['], [(], [)], [,]
//---------------------------------------------------------------------------
const char* TUrlCoder::HexChars = "0123456789ABCDEF";
//---------------------------------------------------------------------------
const int TUrlCoder::HexCharTable[] = {
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, -1, -1, -1, -1, -1, -1,
	-1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
};
//---------------------------------------------------------------------------
__fastcall TUrlCoder::TUrlCoder()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TUrlCoder::~TUrlCoder()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall TUrlCoder::Encode(const AnsiString& AString)
{
	const AnsiString& LSrcStr = AString;
	const char* LSrcPos = LSrcStr.c_str();
	AnsiString LDstStr;
	LDstStr.SetLength(LSrcStr.Length() * 3);
	char* LDstPos = LDstStr.c_str();
	while(*LSrcPos != '\0') {
		if(SafeCharTable[static_cast<unsigned char>(*LSrcPos)]) {
			*LDstPos++ = *LSrcPos++;
			continue;
		}
		*LDstPos++ = '%';
		*LDstPos++ = HexChars[(static_cast<unsigned char>(*LSrcPos) >> (4 * 1)) & 0x0F];
		*LDstPos++ = HexChars[(static_cast<unsigned char>(*LSrcPos) >> (4 * 0)) & 0x0F];
		++LSrcPos;
	}
	return LDstStr.SubString(1, LDstPos - LDstStr.c_str());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TUrlCoder::Decode(const AnsiString& AString)
{
	const char* LSrcPos = AString.c_str();
	AnsiString LDstStr;
	LDstStr.SetLength(AString.Length());
	char* LDstPos = LDstStr.c_str();
	while(*LSrcPos != '\0') {
		if(*LSrcPos != '%') {
			*LDstPos++ = *LSrcPos++;
			continue;
		}
		++LSrcPos;
		int LChar = 0;
		for(int LI = 0; LI < 2; ++LI) {
			int LPart = HexCharTable[static_cast<unsigned char>(*LSrcPos++)];
			if(LPart < 0) {
				throw ENetError("The program cannot URL decode the string.");
			}
			LChar |= LPart << (4 * (1 - LI));
		}
		*LDstPos++ = LChar;
	}
	return LDstStr.SubString(1, LDstPos - LDstStr.c_str());
}
//---------------------------------------------------------------------------
} // Endnamespace Moa_net
//---------------------------------------------------------------------------

