//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointer.h"
#include "Moa_Rect.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_rect {
//---------------------------------------------------------------------------
TSmallPoint __fastcall TPointHelper::GetAsSmallPoint() const
{
	TSmallPoint LSmallPoint = {0};
	LSmallPoint.x = Value.x;
	LSmallPoint.y = Value.y;
	return LSmallPoint;
}
//---------------------------------------------------------------------------
void __fastcall TPointHelper::SetAsSmallPoint(const TSmallPoint& ASmallPoint)
{
	Value = TPoint(ASmallPoint.x, ASmallPoint.y);
}
//---------------------------------------------------------------------------
POINT __fastcall TPointHelper::GetAsWinPoint() const
{
	POINT LWinPoint = {0};
	LWinPoint.x = Value.x;
	LWinPoint.y = Value.y;
	return LWinPoint;
}
//---------------------------------------------------------------------------
void __fastcall TPointHelper::SetAsWinPoint(const POINT& AWinPoint)
{
	Value = TPoint(AWinPoint.x, AWinPoint.y);
}
//---------------------------------------------------------------------------
POINTS __fastcall TPointHelper::GetAsWinSmallPoint() const
{
	POINTS LWinSmallPoint = {0};
	LWinSmallPoint.x = Value.x;
	LWinSmallPoint.y = Value.y;
	return LWinSmallPoint;
}
//---------------------------------------------------------------------------
void __fastcall TPointHelper::SetAsWinSmallPoint(const POINTS& AWinSmallPoint)
{
	Value = TPoint(AWinSmallPoint.x, AWinSmallPoint.y);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPointHelper::GetAsString() const
{
	TAutoPointer<TStrings> LEncoder = new TStringList();
	LEncoder->Capacity = 2;
	LEncoder->Add(Value.x);
	LEncoder->Add(Value.y);
	return LEncoder->CommaText;
}
//---------------------------------------------------------------------------
void __fastcall TPointHelper::SetAsString(const AnsiString& AString)
{
	try {
		TAutoPointer<TStrings> LDecoder = new TStringList();
		LDecoder->CommaText = AString;
		Value = TPoint(
			LDecoder->Strings[0].ToInt(),
			LDecoder->Strings[1].ToInt());
	}
	catch(EListError& LException) {
		throw ERectError(LException.Message);
	}
	catch(EConvertError& LException) {
		throw ERectError(LException.Message);
	}
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper() :
	FValue(0, 0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper(const TPoint& AValue) :
	FValue()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper(const TSmallPoint& AValue) :
	FValue()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper(const POINT& AWinPoint) :
	FValue(AWinPoint.x, AWinPoint.y)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper(const POINTS& AWinSmallPoint) :
	FValue(AWinSmallPoint.x, AWinSmallPoint.y)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::TPointHelper(const TPointHelper& AOther) :
	FValue(AOther.FValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::~TPointHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TPointHelper& __fastcall TPointHelper::operator =(const TPointHelper& AOther)
{
	if(&AOther == this) {
		return *this;
	}
	FValue = AOther.FValue;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TPointHelper::operator ==(const TPointHelper& AOther) const
{
	return
		Value.x == AOther.Value.x &&
		Value.x == AOther.Value.y;
}
//---------------------------------------------------------------------------
bool __fastcall TPointHelper::operator !=(const TPointHelper& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
__fastcall TPointHelper::operator TPoint() const
{
	return Value;
}
//---------------------------------------------------------------------------
TPointHelper& __fastcall TPointHelper::MoveBy(int AHorzDistance, int AVertDistance)
{
	Value = TPoint(Value.y + AHorzDistance, Value.x + AVertDistance);
	return *this;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
RECT __fastcall TRectHelper::GetAsWinRect() const
{
	RECT LRect = {0};
	LRect.left = Value.left;
	LRect.top = Value.top;
	LRect.right = Value.right;
	LRect.bottom = Value.bottom;
	return LRect;
}
//---------------------------------------------------------------------------
void __fastcall TRectHelper::SetAsWinRect(const RECT& AWinRect)
{
	Value = TRect(AWinRect.left, AWinRect.top, AWinRect.right, AWinRect.bottom);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRectHelper::GetAsString() const
{
	TAutoPointer<TStrings> LEncoder = new TStringList();
	LEncoder->Capacity = 4;
	LEncoder->Add(Value.left);
	LEncoder->Add(Value.top);
	LEncoder->Add(Value.right);
	LEncoder->Add(Value.bottom);
	return LEncoder->CommaText;
}
//---------------------------------------------------------------------------
void __fastcall TRectHelper::SetAsString(const AnsiString& AString)
{
	try {
		TAutoPointer<TStrings> LDecoder = new TStringList();
		LDecoder->CommaText = AString;
		Value = TRect(
			LDecoder->Strings[0].ToInt(),
			LDecoder->Strings[1].ToInt(),
			LDecoder->Strings[2].ToInt(),
			LDecoder->Strings[3].ToInt());
	}
	catch(EListError& LException) {
		throw ERectError(LException.Message);
	}
	catch(EConvertError& LException) {
		throw ERectError(LException.Message);
	}
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::TRectHelper() :
	FValue(0, 0, 0, 0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::TRectHelper(const TRect& AValue) :
	FValue(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::TRectHelper(const RECT& AWinRect) :
	FValue(AWinRect.left, AWinRect.top, AWinRect.right, AWinRect.bottom)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::TRectHelper(const TRectHelper& AOther) :
	FValue(AOther.FValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::~TRectHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::operator =(const TRectHelper& AOther)
{
	if(&AOther == this) {
		return *this;
	}
	FValue = AOther.FValue;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TRectHelper::operator ==(const TRectHelper& AOther) const
{
	::SetLastError(NO_ERROR);
	bool LResult = ::EqualRect(&Value, &(AOther.Value));
	if(::GetLastError() != NO_ERROR) {
		throw ERectError("The program could not compare a rectangle.");
	}
	return LResult;
}
//---------------------------------------------------------------------------
bool __fastcall TRectHelper::operator !=(const TRectHelper& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
__fastcall TRectHelper::operator TRect() const
{
	return Value;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::Inflate(int AHorzSize, int AVertSize)
{
	TRect LRect(0, 0, 0, 0);
	if(!::InflateRect(&LRect, AHorzSize, AVertSize)) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::Intersect(const TRect& ARect)
{
	::SetLastError(NO_ERROR);
	TRect LRect(0, 0, 0, 0);
	::IntersectRect(&LRect, &Value, &ARect);
	if(::GetLastError() != NO_ERROR) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::MakeEmpty()
{
	TRect LRect = Value;
	if(!::SetRectEmpty(&LRect)) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::MoveBy(int AHorzDistance, int AVertDistance)
{
	TRect LRect = Value;
	if(!::OffsetRect(&LRect, AHorzDistance, AVertDistance)) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::Subtract(const TRect& ARect)
{
	TRect LRect(0, 0, 0, 0);
	if(!::SubtractRect(&LRect, &Value, &ARect)) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
TRectHelper& __fastcall TRectHelper::Union(const TRect& ARect)
{
	TRect LRect = Value;
	::SetLastError(NO_ERROR);
	::UnionRect(&LRect, &Value, &ARect);
	if(!::GetLastError() != NO_ERROR) {
		throw ERectError("The program could not edit a rectangle.");
	}
	Value = LRect;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TRectHelper::Contains(const TPoint& APoint) const
{
	::SetLastError(NO_ERROR);
	bool LResult = ::PtInRect(&Value, APoint);
	if(::GetLastError() != NO_ERROR) {
		throw ERectError("The program could not compare a rectangle.");
	}
	return LResult;
}
//---------------------------------------------------------------------------
bool __fastcall TRectHelper::Intersects(const TRect& ARect) const
{
	return !TRectHelper(Value).Intersect(ARect).IsEmpty();
}
//---------------------------------------------------------------------------
bool __fastcall TRectHelper::IsEmpty() const
{
	::SetLastError(NO_ERROR);
	bool LResult = ::IsRectEmpty(&Value);
	if(::GetLastError() != NO_ERROR) {
		throw ERectError("The program could not examine a rectangle.");
	}
	return LResult;
}
//---------------------------------------------------------------------------
} // End namespace Moa_rect
//---------------------------------------------------------------------------

