//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointer.h"
#include "Moa_Shell.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_shell {
//---------------------------------------------------------------------------
void __fastcall TFileDrop::AssureNotFinished() const
{
	if(IsFinished()) {
		throw EShellError("The file drop has been already finished.");
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileDrop::GetFile(int AIndex) const
{
	AssureNotFinished();
	if(AIndex < 0 || AIndex >= Count) {
		throw EShellError("The program cannot get the path of the dropped file.");
	}
	AnsiString LFile;
	LFile.SetLength(::DragQueryFile(Handle, AIndex, NULL, 0));
	::DragQueryFile(Handle, AIndex, LFile.c_str(), LFile.Length() + 1);
	return LFile;
}
//---------------------------------------------------------------------------
int __fastcall TFileDrop::GetCount() const
{
	AssureNotFinished();
	return ::DragQueryFile(Handle, 0xFFFFFFFF, NULL, 0);
}
//---------------------------------------------------------------------------
TPoint __fastcall TFileDrop::GetPoint() const
{
	AssureNotFinished();
	TPoint LPoint(0, 0);
	::DragQueryPoint(Handle, &LPoint);
	return LPoint;
}
//---------------------------------------------------------------------------
__fastcall TFileDrop::TFileDrop(HDROP AHandle, bool AAutoFinish) :
	FHandle(AHandle),
	FAutoFinish(AAutoFinish)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFileDrop::~TFileDrop()
{
	if(AutoFinish) {
		Finish();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileDrop::GetFiles(TStrings* AFiles)
{
	TAutoPointer<TStrings> LFiles = new TStringList();
	LFiles->Capacity = Count;
	for(int LI = 0; LI < Count; ++LI) {
		LFiles->Add(Files[LI]);
	}
	AFiles->Assign(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TFileDrop::Finish()
{
	if(IsFinished()) {
		return;
	}
	::DragFinish(Handle);
	FHandle = NULL;
}
//---------------------------------------------------------------------------
bool __fastcall TFileDrop::IsFinished() const
{
	return Handle == NULL;
}
//---------------------------------------------------------------------------
} // End namespace Moa_shell
//---------------------------------------------------------------------------

