//---------------------------------------------------------------------------
#ifndef Moa_ShellH
#define Moa_ShellH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_shell {
//---------------------------------------------------------------------------
class EShellError : public Exception
{
public:
	__fastcall EShellError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileDrop
{
private:
	HDROP FHandle;
	bool FAutoFinish;
	__fastcall TFileDrop(); // Forbidden
	__fastcall TFileDrop(const TFileDrop& AOther); // Forbidden
	void __fastcall AssureNotFinished() const;
	AnsiString __fastcall GetFile(int AIndex) const;
	int __fastcall GetCount() const;
	TPoint __fastcall GetPoint() const;
protected:
public:
	__fastcall TFileDrop(HDROP AHandle, bool AAutoFinish);
	virtual __fastcall ~TFileDrop();
	virtual void __fastcall GetFiles(TStrings* AFiles);
	virtual void __fastcall Finish();
	virtual bool __fastcall IsFinished() const;
	__property HDROP Handle = {read=FHandle};
	__property AnsiString Files[int AIndex] = {read=GetFile};
	__property int Count = {read=GetCount};
	__property TPoint Point = {read=GetPoint};
	__property bool AutoFinish = {read=FAutoFinish, write=FAutoFinish};
};
//---------------------------------------------------------------------------
} // End namespace Moa_shell
using namespace Moa_shell;
//---------------------------------------------------------------------------
#endif

