//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointer.h"
#include "Moa_Text.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_text {
//---------------------------------------------------------------------------
__fastcall TTextCapitalizer::TTextCapitalizer()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TTextCapitalizer::~TTextCapitalizer()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall TTextCapitalizer::MakeLowerCase(const AnsiString& AText)
{
	return Sysutils::LowerCase(AText);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TTextCapitalizer::MakeUpperCase(const AnsiString& AText)
{
	return Sysutils::UpperCase(AText);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TTextCapitalizer::MakeBookTitle(const AnsiString& AText)
{
	if(AText.Length() == 0) {
		return AText;
	}
	AnsiString LSrcText = MakeUpperCase(AText);
	AnsiString LDstText = MakeLowerCase(AText).Unique();
	char* LSrcFirst = LSrcText.c_str();
	char* LDstFirst = LDstText.c_str();
	char* LSrcPos = LSrcFirst;
	char* LDstPos = LDstFirst;
	TAutoArray<WORD> LCharTypes = new WORD[LDstText.Length()];
	if(!::GetStringTypeA(LOCALE_USER_DEFAULT, CT_CTYPE1, LDstText.c_str(), LDstText.Length(), LCharTypes)) {
		throw ETextError("The program cannot get the character types.");
	}
	WORD* LCharTypePos = LCharTypes;
	bool LInSpaces = true;
	while(*LDstPos != '\0') {
		bool LAtSpace = ((*LCharTypePos++) & (C1_SPACE | C1_PUNCT | C1_CNTRL | C1_BLANK)) != 0;
		if(LInSpaces && !LAtSpace) {
			if(::IsDBCSLeadByte(*LDstPos)) {
				*(LDstPos + 0) = *(LSrcPos + 0);
				*(LDstPos + 1) = *(LSrcPos + 1);
			}
			else {
				*(LDstPos + 0) = *(LSrcPos + 0);
			}
		}
		LSrcPos = ::CharNext(LSrcPos);
		LDstPos = ::CharNext(LDstPos);
		LInSpaces = LAtSpace;
	}
	return LDstText;
}
//---------------------------------------------------------------------------
} // End namespace Moa_text
//---------------------------------------------------------------------------

