//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_CapitalizeDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenCapitalizeDialog* OrenCapitalizeDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::Initialize()
{
	try {
		TValues LValues;
		LValues.Part = npBaseName;
		LValues.Case = ccLowerCase;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::UpdateAccess()
{
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenCapitalizeDialog::ValidateInputs()
{
	if(ComboBox11->ItemIndex < 0) {
		return false;
	}
	if(ComboBox12->ItemIndex < 0) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenCapitalizeDialog::TValues __fastcall TOrenCapitalizeDialog::GetInputs()
{
	TValues LInputs = Values;
	switch(ComboBox11->ItemIndex) {
	case 0: LInputs.Part = npName; break;
	case 1: LInputs.Part = npBaseName; break;
	case 2: LInputs.Part = npExtension; break;
	default: throw EInvalidOperation("The part is not specified.");
	}
	switch(ComboBox12->ItemIndex) {
	case 0: LInputs.Case = ccLowerCase; break;
	case 1: LInputs.Case = ccUpperCase; break;
	case 2: LInputs.Case = ccBookTitle; break;
	default: throw EInvalidOperation("The case is not specified.");
	}
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenCapitalizeDialog::SetInputs(const TValues& AInputs)
{
	switch(AInputs.Part) {
	case npName: ComboBox11->ItemIndex = 0; break;
	case npBaseName: ComboBox11->ItemIndex = 1; break;
	case npExtension: ComboBox11->ItemIndex = 2; break;
	default: ComboBox11->ItemIndex = -1; break;
	}
	switch(AInputs.Case) {
	case ccLowerCase: ComboBox12->ItemIndex = 0; break;
	case ccUpperCase: ComboBox12->ItemIndex = 1; break;
	case ccBookTitle: ComboBox12->ItemIndex = 2; break;
	default: ComboBox12->ItemIndex = -1; break;
	}
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenCapitalizeDialog::TOrenCapitalizeDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenCapitalizeDialog::~TOrenCapitalizeDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenCapitalizeDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

