//---------------------------------------------------------------------------
// Version: 2.2.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_InsertDialog.h"
#include "Oren_NumbersDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenInsertDialog* OrenInsertDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::Button11Click(TObject* ASender)
{
	OrenNumbersDialog->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::ComboBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::ComboBox12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::Edit11Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::RadioButton11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::RadioButton12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::RadioButton13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::Initialize()
{
	try {
		if(OrenNumbersDialog == NULL) {
			OrenNumbersDialog = new TOrenNumbersDialog(Application);
		}
		TValues LValues;
		LValues.Part = npBaseName;
		LValues.Position = ipHead;
		LValues.Text.Kind = slCustom;
		LValues.Text.Set.Custom.Text = AnsiString();
		LValues.Text.Set.Number = OrenNumbersDialog->Values;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::UpdateAccess()
{
	Edit11->Enabled = RadioButton11->Checked;
	Button11->Enabled = RadioButton12->Checked;
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenInsertDialog::ValidateInputs()
{
	if(ComboBox11->ItemIndex < 0 || ComboBox12->ItemIndex < 0) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenInsertDialog::TValues __fastcall TOrenInsertDialog::GetInputs()
{
	TValues LInputs;
	switch(ComboBox11->ItemIndex) {
	case 0: LInputs.Part = npName; break;
	case 1: LInputs.Part = npBaseName; break;
	case 2: LInputs.Part = npExtension; break;
	default: throw EInvalidOperation("The part is not specified.");
	}
	switch(ComboBox12->ItemIndex) {
	case 0: LInputs.Position = ipHead; break;
	case 1: LInputs.Position = ipTail; break;
	default: throw EInvalidOperation("The position is not specified.");
	}
	if(RadioButton11->Checked) {
		LInputs.Text.Kind = slCustom;
	}
	else if(RadioButton12->Checked) {
		LInputs.Text.Kind = slNumber;
	}
	else if(RadioButton13->Checked) {
		LInputs.Text.Kind = slClipboard;
	}
	else {
		throw EInvalidOperation("The kind is not specified.");
	}
	LInputs.Text.Set.Custom.Text = Edit11->Text;
	LInputs.Text.Set.Number = OrenNumbersDialog->Values;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenInsertDialog::SetInputs(const TValues& AInputs)
{
	switch(AInputs.Part) {
	case npName: ComboBox11->ItemIndex = 0; break;
	case npBaseName: ComboBox11->ItemIndex = 1; break;
	case npExtension: ComboBox11->ItemIndex = 2; break;
	default: ComboBox11->ItemIndex = -1; break;
	}
	switch(AInputs.Position) {
	case ipHead: ComboBox12->ItemIndex = 0; break;
	case ipTail: ComboBox12->ItemIndex = 1; break;
	default: ComboBox12->ItemIndex = -1; break;
	}
	RadioButton11->Checked = AInputs.Text.Kind == slCustom;
	RadioButton12->Checked = AInputs.Text.Kind == slNumber;
	RadioButton13->Checked = AInputs.Text.Kind == slClipboard;
	Edit11->Text = AInputs.Text.Set.Custom.Text;
	OrenNumbersDialog->Values = AInputs.Text.Set.Number;
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenInsertDialog::TOrenInsertDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenInsertDialog::~TOrenInsertDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenInsertDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

