//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_List.h"
#include "Oren_ListEdit.h"
#include "Oren_ListEditCommand.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_listeditcommand {
//---------------------------------------------------------------------------
void __fastcall TListEditCommand::Initialize()
{
	try {
		FInvoker = new TInvoker();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TListEditCommand::Uninitialize()
{
	delete FInvoker;
	FInvoker = NULL;
}
//---------------------------------------------------------------------------
__fastcall TListEditCommand::TListEditCommand(TListViewModel* AControl) :
	TEditCommand(),
	FControl(AControl),
	FInvoker(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TListEditCommand::~TListEditCommand()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TListEditCommand::Execute()
{
	Control->Update(true);
	try {
		Control->ClearSelection();
		while(Invoker->CanExecute()) {
			Invoker->Execute();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(true);
		throw;
	}
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TListEditCommand::Undo()
{
	Control->Update(true);
	try {
		Control->ClearSelection();
		while(Invoker->CanUndo()) {
			Invoker->Undo();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(true);
		throw;
	}
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TListEditCommand::Redo()
{
	Control->Update(true);
	try {
		Control->ClearSelection();
		while(Invoker->CanRedo()) {
			Invoker->Redo();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(true);
		throw;
	}
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TAddSubCommand::TAddSubCommand(TListViewModel* AControl, TRenameItem* AItem) :
	TCommand(),
	FControl(AControl),
	FItem(AItem)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAddSubCommand::~TAddSubCommand()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TAddSubCommand::Execute()
{
	TRenameList(Control).Add(Item);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TAddSubCommand::Undo()
{
	TRenameList(Control).Remove(Item);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TAddSubCommand::Redo()
{
	TRenameList(Control).Add(Item);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TDeleteSubCommand::TDeleteSubCommand(TListViewModel* AControl, int AIndex) :
	TCommand(),
	FControl(AControl),
	FIndex(AIndex),
	FItem(static_cast<TRenameItem*>(Control->Items[AIndex]->Value))
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TDeleteSubCommand::~TDeleteSubCommand()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TDeleteSubCommand::Execute()
{
	TRenameList(Control).Delete(Index);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TDeleteSubCommand::Undo()
{
	TRenameList(Control).Add(Item);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TDeleteSubCommand::Redo()
{
	TRenameList(Control).Remove(Item);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
} // End namespace Oren_listeditcommand
//---------------------------------------------------------------------------

