//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Clipbrd.hpp>
#include "Moa_AutoPointer.h"
#include "Moa_File.h"
#include "Moa_Shell.h"
#include "Oren_ListEdit.h"
#include "Oren_MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOrenMainForm* OrenMainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	FileNewAc->Execute();
	SaveSettings();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
	if(Modified) {
		Modified = false;
		UpdateAccess();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::FileNewAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		FileHandler->New(true);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::FileExitAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		Close();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditUndoAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Undo();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditRedoAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Redo();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditCutAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Cut();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditCopyAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Copy();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditPasteAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Paste();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditAddDirectoryAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->AddDirectory();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditAddRegularFilesAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->AddRegularFiles();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditDereferenceShortcutsAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->DereferenceShortcuts = EditDereferenceShortcutsAc->Checked;
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditDeleteAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->Delete();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectAllAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectAll();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByTypeDirectoryAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByType(Oren_rename::ftDirectory);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByTypeFileAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByType(Oren_rename::ftRegularFile);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByResultSucceededAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByResult(reSucceeded);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByResultFailedAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByResult(reFailed);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByResultSkippedAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByResult(reSkipped);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditSelectByResultNoneAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->SelectByResult(reNone);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EditReverseSelectionAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		EditHandler->ReverseSelection();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameCopyAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->Copy();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameInsertAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->Insert();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameOverwriteAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->Overwrite();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameReplaceAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->Replace();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameCapitalizeAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->Capitalize();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameUrlEncodeAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->UrlEncode();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameUrlDecodeAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->UrlDecode();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameFreeEditAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		NameHandler->FreeEdit();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::NameEnterAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ListView1->ClearSelection();
		ListView1->ItemFocused->EditCaption();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewToolbarAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->ShowToolbar = ViewToolbarAc->Checked;
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewStatusBarAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->ShowStatusBar = ViewStatusBarAc->Checked;
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewRememberPlacementAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->RememberPlacement = ViewRememberPlacementAc->Checked;
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewSortByNewNameAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->SortByNewName();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewSortByOldNameAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->SortByOldName();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewSortByDirectoryAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->SortByDirectory();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewSortByTypeAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->SortByType();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewSortByResultAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->SortByResult();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewInvertAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->Invert();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewMoveUpAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->MoveUp();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ViewMoveDownAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		ViewHandler->MoveDown();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::RenamePerformAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		RenameHandler->Perform();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::RenameRestoreAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		RenameHandler->Undo(true);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::RenameResultsAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		RenameHandler->ShowResults();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::HelpContentsAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		HelpHandler->ShowContents();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::HelpAboutAcExecute(TObject* ASender)
{
	BeginAction();
	try {
		HelpHandler->ShowAbout();
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ListView1Change(TObject* ASender, TListItem* AItem, TItemChange AChange)
{
	Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ListView1ColumnClick(TObject* ASender, TListColumn* AColumn)
{
	switch(AColumn->Index) {
	case 0:
		ViewSortByNewNameAc->Execute();
		break;
	case 1:
		ViewSortByOldNameAc->Execute();
		break;
	case 2:
		ViewSortByDirectoryAc->Execute();
		break;
	case 3:
		ViewSortByTypeAc->Execute();
		break;
	case 4:
		ViewSortByResultAc->Execute();
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ListView1Data(TObject* ASender, TListItem* AItem)
{
	static const AnsiString LBusyMessage = "(Busy...)";

	if(AItem->Index < 0 || AItem->Index >= Control->Count) {
		return;
	}
	if(RenameHandler->IsBusy()) {
		AItem->Caption = LBusyMessage;
		AItem->ImageIndex = -1;
		AItem->StateIndex = -1;
		return;
	}
	TRenameItem* LItem = static_cast<TRenameItem*>(Control->Items[AItem->Index]->Value);
	AItem->Caption = TItemUtils::DescribePath(LItem->NewName);
	AItem->SubItems->Capacity = 4;
	AItem->SubItems->Add(TItemUtils::DescribePath(LItem->OldName));
	AItem->SubItems->Add(TItemUtils::DescribePath(LItem->Directory));
	AItem->SubItems->Add(TItemUtils::DescribeType(LItem->Type));
	AItem->SubItems->Add(TItemUtils::DescribeResult(LItem->Result));
	AItem->ImageIndex = TItemUtils::DetermineImageIndex(LItem);
	AItem->StateIndex = TItemUtils::DetermineStateIndex(LItem);
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ListView1Edited(TObject* ASender, TListItem* AItem, AnsiString& AS)
{
	BeginAction();
	try {
		NameHandler->Enter(AItem->Index, AS);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
const AnsiString TOrenMainForm::SettingsFile = ExtractFilePath(Application->ExeName) + "Settings.ini";
const AnsiString TOrenMainForm::iniCurrentDirectory = "CurrentDirectory";
const AnsiString TOrenMainForm::iniEditHandler = "EditHandler";
const AnsiString TOrenMainForm::iniFileHandler = "FileHandler";
const AnsiString TOrenMainForm::iniHelpHandler = "HelpHandler";
const AnsiString TOrenMainForm::iniMainForm = "MainForm";
const AnsiString TOrenMainForm::iniNameHandler = "NameHandler";
const AnsiString TOrenMainForm::iniRenameHandler = "RenameHandler";
const AnsiString TOrenMainForm::iniSystem = "System";
const AnsiString TOrenMainForm::iniViewHandler = "ViewHandler";
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::Initialize()
{
	try {
		FControl = new TListViewModel(ListView1);
		FInvoker = new TInvoker();
		FItems = new TObjectList();
		FFileHandler = new TFileHandler(Control, Invoker, Items);
		FEditHandler = new TEditHandler(Control, Invoker, Items);
		FNameHandler = new TNameHandler(Control, Invoker, Items);
		FViewHandler = new TViewHandler(Control, Invoker, Items);
		FRenameHandler = new TRenameHandler(Control, Invoker, Items);
		FHelpHandler = new THelpHandler(Control, Invoker, Items);
		FClipboardWatcher = new TClipboardWatcher();
		Application->OnIdle = ApplicationIdle;
		::DragAcceptFiles(Handle, true);
		ViewHandler->Form = this;
		ViewHandler->Toolbar = ToolBar1;
		ViewHandler->StatusBar = StatusBar1;
		ViewHandler->ListView = ListView1;
		ViewHandler->AdjustListColumns();
		ClipboardWatcher->OnChange = ClipboardWatcherChange;
		ClipboardWatcher->Enabled = true;
		UpdateAccess();
		LoadSettings();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::Uninitialize()
{
	delete FClipboardWatcher;
	FClipboardWatcher = NULL;

	delete FHelpHandler;
	FHelpHandler = NULL;

	delete FRenameHandler;
	FRenameHandler = NULL;

	delete FViewHandler;
	FViewHandler = NULL;

	delete FNameHandler;
	FNameHandler = NULL;

	delete FEditHandler;
	FEditHandler = NULL;

	delete FFileHandler;
	FFileHandler = NULL;

	delete FItems;
	FItems = NULL;

	delete FInvoker;
	FInvoker = NULL;

	delete FControl;
	FControl = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::LoadSettings()
{
	if(!FileExists(SettingsFile)) {
		return;
	}

	TAutoPointer<TMemIniFile> LFile = new TMemIniFile(SettingsFile);
	TAutoPointer<TIniSection> LSection = new TIniSection();

	LSection->Enter(iniSystem);
	TFiles().CurrentDirectory = LFile->ReadString(
		LSection->Section,
		iniCurrentDirectory,
		TFiles().CurrentDirectory);
	LSection->Leave();

	LSection->Enter(iniMainForm);
	LSection->Enter(iniFileHandler);
	FileHandler->LoadSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniEditHandler);
	EditHandler->LoadSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniNameHandler);
	NameHandler->LoadSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniViewHandler);
	ViewHandler->LoadSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniRenameHandler);
	RenameHandler->LoadSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniHelpHandler);
	HelpHandler->LoadSettings(LFile, LSection);
	LSection->Leave();
	LSection->Leave();

	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::SaveSettings()
{
	TAutoPointer<TMemIniFile> LFile = new TMemIniFile(SettingsFile);
	TAutoPointer<TIniSection> LSection = new TIniSection();

	LSection->Enter(iniSystem);
	LFile->WriteString(
		LSection->Section,
		iniCurrentDirectory,
		TFiles().CurrentDirectory);
	LSection->Leave();

	LSection->Enter(iniMainForm);
	LSection->Enter(iniFileHandler);
	FileHandler->SaveSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniEditHandler);
	EditHandler->SaveSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniNameHandler);
	NameHandler->SaveSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniViewHandler);
	ViewHandler->SaveSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniRenameHandler);
	RenameHandler->SaveSettings(LFile, LSection);
	LSection->Leave();

	LSection->Enter(iniHelpHandler);
	HelpHandler->SaveSettings(LFile, LSection);
	LSection->Leave();
	LSection->Leave();

	LFile->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::HandleParams()
{
	if(ParamCount() == 0) {
		return;
	}
	BeginAction();
	try {
		TAutoPointer<TStringList> LFiles = new TStringList();
		LFiles->Capacity = ParamCount();
		for(int LI = 0; LI < ParamCount(); ++LI) {
			LFiles->Add(ParamStr(LI + 1));
		}
		EditHandler->Add(LFiles);
	}
	catch(...) {
	 	EndAction();
		throw;
	}
 	EndAction();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::UpdateAccess()
{
	// Update Enabled
	int LCount = ListView1->Items->Count;
	int LSelCount = ListView1->SelCount;
	EditUndoAc->Enabled = EditHandler->CanUndo();
	EditRedoAc->Enabled = EditHandler->CanRedo();
	EditCutAc->Enabled = LSelCount > 0;
	EditCopyAc->Enabled = LSelCount > 0;
	EditPasteAc->Enabled = Clipboard()->HasFormat(CF_TEXT);
	EditDeleteAc->Enabled = LSelCount > 0;
	NameCopyAc->Enabled = LSelCount > 0;
	NameInsertAc->Enabled = LSelCount > 0;
	NameOverwriteAc->Enabled = LSelCount > 0;
	NameReplaceAc->Enabled = LSelCount > 0;
	NameCapitalizeAc->Enabled = LSelCount > 0;
	NameUrlEncodeAc->Enabled = LSelCount > 0;
	NameUrlDecodeAc->Enabled = LSelCount > 0;
	NameFreeEditAc->Enabled = LSelCount > 0;
	NameEnterAc->Enabled = ListView1->ItemFocused != NULL;
	ViewMoveUpAc->Enabled = LSelCount > 0;
	ViewMoveDownAc->Enabled = LSelCount > 0;
	RenamePerformAc->Enabled = LCount > 0;
	RenameRestoreAc->Enabled = RenameHandler->CanUndo();

	// Update Checked
	EditDereferenceShortcutsAc->Checked = EditHandler->DereferenceShortcuts;
	ViewToolbarAc->Checked = ViewHandler->ShowToolbar;
	ViewStatusBarAc->Checked = ViewHandler->ShowStatusBar;
	ViewRememberPlacementAc->Checked = ViewHandler->RememberPlacement;

	// Update Visible
	ToolBar1->Visible = ViewHandler->ShowToolbar;
	StatusBar1->Visible = ViewHandler->ShowStatusBar;

	// Update the status message
	if(LSelCount > 0) {
		Status = AnsiString().sprintf("%d items selected", LSelCount);
	}
	else {
		Status = AnsiString().sprintf("%d items", LCount);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::BeginAction()
{
	if(++FActionCount == 1) {
		Screen->Cursor = crHourGlass;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::EndAction()
{
	if(--FActionCount == 0) {
		Modified = true;
		Screen->Cursor = crDefault;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ApplicationIdle(TObject* ASender, bool& ADone)
{
	ADone = true;
	Application->OnIdle = NULL;
	HandleParams();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::ClipboardWatcherChange(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::WMDropFiles(TMessage& AMessage)
{
	TFileDrop LFileDrop(reinterpret_cast<HDROP>(AMessage.WParam), true);
	BeginAction();
	try {
		::SetForegroundWindow(Handle);
		TAutoPointer<TStringList> LFiles = new TStringList();
		LFileDrop.GetFiles(LFiles);
		LFileDrop.Finish();
		EditHandler->Add(LFiles);
	}
	catch(...) {
		EndAction();
		throw;
	}
	EndAction();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOrenMainForm::GetStatus()
{
	return StatusBar1->SimpleText;
}
//---------------------------------------------------------------------------
void __fastcall TOrenMainForm::SetStatus(const AnsiString& AStatus)
{
	StatusBar1->SimpleText = AStatus;
}
//---------------------------------------------------------------------------
__fastcall TOrenMainForm::TOrenMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FControl(NULL),
	FInvoker(NULL),
	FItems(NULL),
	FFileHandler(NULL),
	FEditHandler(NULL),
	FNameHandler(NULL),
	FRenameHandler(NULL),
	FViewHandler(NULL),
	FHelpHandler(NULL),
	FClipboardWatcher(NULL),
	FActionCount(0),
	FModified(false)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenMainForm::~TOrenMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenMainForm::IsShortCut(TWMKey& AMessage)
{
	if(ListView1->IsEditing()) {
		return false;
	}
	return TForm::IsShortCut(AMessage);
}
//---------------------------------------------------------------------------

