//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_NameEditCommand.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_nameeditcommand {
//---------------------------------------------------------------------------
void __fastcall TNameEditCommand::Initialize()
{
	try {
		FInvoker = new TInvoker();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TNameEditCommand::Uninitialize()
{
	delete FInvoker;
	FInvoker = NULL;
}
//---------------------------------------------------------------------------
__fastcall TNameEditCommand::TNameEditCommand(TListViewModel* AControl) :
	TEditCommand(),
	FControl(AControl),
	FInvoker(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TNameEditCommand::~TNameEditCommand()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TNameEditCommand::Execute()
{
	Control->Update(false);
	try {
		while(Invoker->CanExecute()) {
			Invoker->Execute();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(false);
		throw;
	}
	Control->UpdateControl(false);
}
//---------------------------------------------------------------------------
void __fastcall TNameEditCommand::Undo()
{
	Control->Update(false);
	try {
		while(Invoker->CanUndo()) {
			Invoker->Undo();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(false);
		throw;
	}
	Control->UpdateControl(false);
}
//---------------------------------------------------------------------------
void __fastcall TNameEditCommand::Redo()
{
	Control->Update(false);
	try {
		while(Invoker->CanRedo()) {
			Invoker->Redo();
		}
		Results = Results << crCompleted << crUndoable << crRedoable;
	}
	catch(...) {
		Control->UpdateControl(false);
		throw;
	}
	Control->UpdateControl(false);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TSetSubCommand::Set(const TValues& AValues)
{
	Item->NewName = AValues.NewName;
	Item->Result = AValues.Result;
}
//---------------------------------------------------------------------------
__fastcall TSetSubCommand::TSetSubCommand(TRenameItem* AItem, const AnsiString& ANewValue) :
	TCommand(),
	FItem(AItem),
	FOldValues(),
	FNewValues()
{
	FOldValues.NewName = AItem->NewName;
	FOldValues.Result = AItem->Result;
	FNewValues.NewName = ANewValue;
	FNewValues.Result = reNone;
}
//---------------------------------------------------------------------------
__fastcall TSetSubCommand::~TSetSubCommand()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSetSubCommand::Execute()
{
	Set(NewValues);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TSetSubCommand::Undo()
{
	Set(OldValues);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
void __fastcall TSetSubCommand::Redo()
{
	Set(NewValues);
	Results = Results << crCompleted << crUndoable << crRedoable;
}
//---------------------------------------------------------------------------
} // End namespace Oren_nameeditcommand
//---------------------------------------------------------------------------

