//---------------------------------------------------------------------------
#ifndef Oren_NameEditCommandH
#define Oren_NameEditCommandH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Oren_EditCommand.h"
//---------------------------------------------------------------------------
namespace Oren_nameeditcommand {
//---------------------------------------------------------------------------
class TNameEditCommand : public TEditCommand
{
private:
	TListViewModel* FControl;
	TInvoker* FInvoker;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
protected:
	__property TListViewModel* Control = {read=FControl};
public:
	__fastcall TNameEditCommand(TListViewModel* AControl);
	virtual __fastcall ~TNameEditCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
	__property TInvoker* Invoker = {read=FInvoker};
};
//---------------------------------------------------------------------------
class TSetSubCommand : public TCommand
{
protected:
	struct TValues
	{
		AnsiString NewName;
		TRenameResult Result;
	};
private:
	TRenameItem* FItem;
	TValues FOldValues;
	TValues FNewValues;
protected:
	virtual void __fastcall Set(const TValues& AValues);
	__property TRenameItem* Item = {read=FItem};
	__property TValues OldValues = {read=FOldValues};
	__property TValues NewValues = {read=FNewValues};
public:
	__fastcall TSetSubCommand(TRenameItem* AItem, const AnsiString& ANewValue);
	virtual __fastcall ~TSetSubCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
};
//---------------------------------------------------------------------------
} // End namespace Oren_nameeditcommand
using namespace Oren_nameeditcommand;
//---------------------------------------------------------------------------
#endif

