//---------------------------------------------------------------------------
#ifndef Oren_ProgressDialogH
#define Oren_ProgressDialogH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TOrenProgressDialog : public TForm
{
__published:
	TButton *CommandButton;
	TLabel* MessageLabel;
	TProgressBar* ProgressBar;
	void __fastcall CommandButtonClick(TObject* ASender);
private:
	bool FModal;
	TNotifyEvent FOnExecute;
protected:
	static const UINT WM_EXECUTE = WM_APP + 0;
	virtual void __fastcall WMExecute(TMessage& AMessage);
	DYNAMIC void __fastcall DoShow();
	virtual void __fastcall DoExecute();
	AnsiString __fastcall GetMessage();
	void __fastcall SetMessage(const AnsiString& AMessage);
	AnsiString __fastcall GetCommand();
	void __fastcall SetCommand(const AnsiString& ACommand);
	int __fastcall GetProgress();
	void __fastcall SetProgress(int AProgress);
public:
	__fastcall TOrenProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TOrenProgressDialog();
	virtual void __fastcall Execute(bool AModal);
	virtual void __fastcall CloseDialog();
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_EXECUTE, TMessage, WMExecute);
	END_MESSAGE_MAP(TForm);
	__property AnsiString Message = {read=GetMessage, write=SetMessage};
	__property AnsiString Command = {read=GetCommand, write=SetCommand};
	__property int Progress = {read=GetProgress, write=SetProgress};
	__property bool Modal = {read=FModal};
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
};
//---------------------------------------------------------------------------
extern PACKAGE TOrenProgressDialog* OrenProgressDialog;
//---------------------------------------------------------------------------
#endif

