//---------------------------------------------------------------------------
#ifndef Oren_RenameCommandH
#define Oren_RenameCommandH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Oren_ActionCommand.h"
namespace Oren_renametask { class TRenameTask; } using namespace Oren_renametask;
//---------------------------------------------------------------------------
namespace Oren_renamecommand {
//---------------------------------------------------------------------------
class TRenameCommand : public TActionCommand
{
private:
	TListViewModel* FControl;
	TInvoker* FInvoker;
	TRenameTask* FTask;
	Exception* FAsyncException;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Execute(TRenameTask* ATask);
	void __fastcall HandleAsyncException();
	void __fastcall ProgressDialogExecute(TObject* ASender);
	void __fastcall ProgressDialogCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall TaskProgress(TObject* ASender, int AProgress);
	void __fastcall TaskTerminate(TObject* ASender);
	void __fastcall TaskException(TObject* ASender, Exception* AException);
protected:
	__property TListViewModel* Control = {read=FControl};
	__property TRenameTask* Task = {read=FTask};
	__property Exception* AsyncException = {read=FAsyncException};
public:
	__fastcall TRenameCommand(TListViewModel* AControl);
	virtual __fastcall ~TRenameCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
	__property TInvoker* Invoker = {read=FInvoker};
};
//---------------------------------------------------------------------------
class TRenameSubCommand : public TCommand
{
private:
	TRenameItem* FItem;
	AnsiString FOldValue;
	AnsiString FNewValue;
protected:
	virtual void __fastcall Rename(bool AForward);
	__property TRenameItem* Item = {read=FItem};
	__property AnsiString OldValue = {read=FOldValue};
	__property AnsiString NewValue = {read=FNewValue};
public:
	__fastcall TRenameSubCommand(TRenameItem* AItem);
	virtual __fastcall ~TRenameSubCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
};
//---------------------------------------------------------------------------
} // End namespace Oren_renamecommand
using namespace Oren_renamecommand;
//---------------------------------------------------------------------------
#endif

