//---------------------------------------------------------------------------
#ifndef Oren_RenameTaskH
#define Oren_RenameTaskH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Moa_ListViewModel.h"
#include "Moa_Task.h"
#include "Oren_Rename.h"
//---------------------------------------------------------------------------
namespace Oren_renametask {
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TRenameTaskProgressEvent)(TObject* ASender, int AProgress);
//---------------------------------------------------------------------------
class TRenameTask : public TTask
{
public:
private:
	TListViewModel* FControl;
	TInvoker* FInvoker;
	int FProgress;
	TRenameTaskProgressEvent FOnProgress;
	void __fastcall ResetResults();
	void __fastcall ExecuteCommands();
	void __fastcall DoProgress(int AProgress);
	void __fastcall DoProgressInMainThread(void* AData);
	void __fastcall SetProgress(int AProgress);
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall ExecuteNext() = 0;
	__property TListViewModel* Control = {read=FControl};
	__property TInvoker* Invoker = {read=FInvoker};
	__property int Progress = {read=FProgress, write=SetProgress};
public:
	__fastcall TRenameTask(TListViewModel* AControl, TInvoker* AInvoker);
	virtual __fastcall ~TRenameTask();
	__property TRenameTaskProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
};
//---------------------------------------------------------------------------
class TDoRenameTask : public TRenameTask
{
public:
private:
	void __fastcall AddCommands();
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall ExecuteNext();
public:
	__fastcall TDoRenameTask(TListViewModel* AControl, TInvoker* AInvoker);
	virtual __fastcall ~TDoRenameTask();
};
//---------------------------------------------------------------------------
class TUndoRenameTask : public TRenameTask
{
public:
private:
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall ExecuteNext();
public:
	__fastcall TUndoRenameTask(TListViewModel* AControl, TInvoker* AInvoker);
	virtual __fastcall ~TUndoRenameTask();
};
//---------------------------------------------------------------------------
class TRedoRenameTask : public TRenameTask
{
public:
private:
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall ExecuteNext();
public:
	__fastcall TRedoRenameTask(TListViewModel* AControl, TInvoker* AInvoker);
	virtual __fastcall ~TRedoRenameTask();
};
//---------------------------------------------------------------------------
} // End namespace Oren_renametask
using namespace Oren_renametask;
//---------------------------------------------------------------------------
#endif

