//---------------------------------------------------------------------------
// Version: 2.2.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_NumbersDialog.h"
#include "Oren_ReplaceDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenReplaceDialog* OrenReplaceDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::Button11Click(TObject* ASender)
{
	OrenNumbersDialog->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::Edit11Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::RadioButton11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::RadioButton12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::RadioButton13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::Initialize()
{
	try {
		if(OrenNumbersDialog == NULL) {
			OrenNumbersDialog = new TOrenNumbersDialog(Application);
		}
		TValues LValues;
		LValues.Part = npBaseName;
		LValues.OldText = AnsiString();
		LValues.NewText.Kind = slCustom;
		LValues.NewText.Set.Custom.Text = AnsiString();
		LValues.NewText.Set.Number = OrenNumbersDialog->Values;
		LValues.MatchCase = false;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::UpdateAccess()
{
	Edit12->Enabled = RadioButton11->Checked;
	Button11->Enabled = RadioButton12->Checked;
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenReplaceDialog::ValidateInputs()
{
	if(ComboBox11->ItemIndex < 0) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenReplaceDialog::TValues __fastcall TOrenReplaceDialog::GetInputs()
{
	TValues LInputs;
	switch(ComboBox11->ItemIndex) {
	case 0: LInputs.Part = npName; break;
	case 1: LInputs.Part = npBaseName; break;
	case 2: LInputs.Part = npExtension; break;
	default: throw EInvalidOperation("The part is not specified.");
	}
	LInputs.OldText = Edit11->Text;
	if(RadioButton11->Checked) {
		LInputs.NewText.Kind = slCustom;
	}
	else if(RadioButton12->Checked) {
		LInputs.NewText.Kind = slNumber;
	}
	else if(RadioButton13->Checked) {
		LInputs.NewText.Kind = slClipboard;
	}
	else {
		throw EInvalidOperation("The kind is not specified.");
	}
	LInputs.NewText.Set.Custom.Text = Edit12->Text;
	LInputs.NewText.Set.Number = OrenNumbersDialog->Values;
	LInputs.MatchCase = CheckBox11->Checked;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenReplaceDialog::SetInputs(const TValues& AInputs)
{
	switch(AInputs.Part) {
	case npName: ComboBox11->ItemIndex = 0; break;
	case npBaseName: ComboBox11->ItemIndex = 1; break;
	case npExtension: ComboBox11->ItemIndex = 2; break;
	default: ComboBox11->ItemIndex = -1; break;
	}
	Edit11->Text = AInputs.OldText;
	RadioButton11->Checked = AInputs.NewText.Kind == slCustom;
	RadioButton12->Checked = AInputs.NewText.Kind == slNumber;
	RadioButton13->Checked = AInputs.NewText.Kind == slClipboard;
	Edit12->Text = AInputs.NewText.Set.Custom.Text;
	OrenNumbersDialog->Values = AInputs.NewText.Set.Number;
	CheckBox11->Checked = AInputs.MatchCase;
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenReplaceDialog::TOrenReplaceDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenReplaceDialog::~TOrenReplaceDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenReplaceDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

