//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_ResultsDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenResultsDialog* OrenResultsDialog = NULL;
//---------------------------------------------------------------------------
namespace Oren_resultsdialog {
//---------------------------------------------------------------------------
int __fastcall TResultsCounter::GetTotal()
{
	return Succeeded + Failed + Skipped + None;
}
//---------------------------------------------------------------------------
__fastcall TResultsCounter::TResultsCounter() :
	TObject(),
	FSucceeded(0),
	FFailed(0),
	FSkipped(0),
	FNone(0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TResultsCounter::~TResultsCounter()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TResultsCounter::Increment(TRenameResult AResult)
{
	switch(AResult) {
	case reSucceeded:
		Succeeded = Succeeded + 1;
		break;
	case reFailed:
		Failed = Failed + 1;
		break;
	case reSkipped:
		Skipped = Skipped + 1;
		break;
	case reNone:
		None = None + 1;
		break;
	default:
		throw ERenameError("The result is not supported.");
	}
}
//---------------------------------------------------------------------------
void __fastcall TResultsCounter::Reset()
{
	Succeeded = 0;
	Failed = 0;
	Skipped = 0;
	None = 0;
}
//---------------------------------------------------------------------------
} // End namespace Oren_resultsdialog
//---------------------------------------------------------------------------
void __fastcall TOrenResultsDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenResultsDialog::Initialize()
{
	try {
		FCounter = new TResultsCounter();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenResultsDialog::Uninitialize()
{
	delete FCounter;
	FCounter = NULL;
}
//---------------------------------------------------------------------------
__fastcall TOrenResultsDialog::TOrenResultsDialog(TComponent* AOwner) :
	TForm(AOwner),
	FCounter(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenResultsDialog::~TOrenResultsDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TOrenResultsDialog::Execute()
{
	Label12->Caption = Counter->Succeeded;
	Label14->Caption = Counter->Failed;
	Label16->Caption = Counter->Skipped;
	Label18->Caption = Counter->None;
	Label1A->Caption = Counter->Total;
	ShowModal();
}
//---------------------------------------------------------------------------

