//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_UrlEncodingDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenUrlEncodingDialog* OrenUrlEncodingDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::Initialize()
{
	try {
		TValues LValues;
		LValues.Part = npBaseName;
		LValues.Encoding = ceUtf8;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::UpdateAccess()
{
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenUrlEncodingDialog::ValidateInputs()
{
	if(ComboBox11->ItemIndex < 0) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenUrlEncodingDialog::TValues __fastcall TOrenUrlEncodingDialog::GetInputs()
{
	TValues LInputs;
	switch(ComboBox11->ItemIndex) {
	case 0: LInputs.Part = npName; break;
	case 1: LInputs.Part = npBaseName; break;
	case 2: LInputs.Part = npExtension; break;
	default: throw EInvalidOperation("The part is not specified.");
	}
	switch(ComboBox12->ItemIndex) {
	case 0: LInputs.Encoding = ceUtf8; break;
	case 1: LInputs.Encoding = ceAnsi; break;
	default: throw EInvalidOperation("The character encoding is not specified.");
	}
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenUrlEncodingDialog::SetInputs(const TValues& AInputs)
{
	switch(AInputs.Part) {
	case npName: ComboBox11->ItemIndex = 0; break;
	case npBaseName: ComboBox11->ItemIndex = 1; break;
	case npExtension: ComboBox11->ItemIndex = 2; break;
	default: ComboBox11->ItemIndex = -1; break;
	}
	switch(AInputs.Encoding) {
	case ceUtf8: ComboBox12->ItemIndex = 0; break;
	case ceAnsi: ComboBox12->ItemIndex = 1; break;
	default: ComboBox12->ItemIndex = -1; break;
	}
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenUrlEncodingDialog::TOrenUrlEncodingDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenUrlEncodingDialog::~TOrenUrlEncodingDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenUrlEncodingDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

