//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_Window.h"
#include "Oren_ListEdit.h"
#include "Oren_ViewHandler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_viewhandler {
//---------------------------------------------------------------------------
const AnsiString TViewHandler::iniBottom = "Bottom";
const AnsiString TViewHandler::iniBounds = "Bounds";
const AnsiString TViewHandler::iniColumn = "Column";
const AnsiString TViewHandler::iniForm = "Form";
const AnsiString TViewHandler::iniLeft = "Left";
const AnsiString TViewHandler::iniListView = "ListView";
const AnsiString TViewHandler::iniMainForm = "MainForm";
const AnsiString TViewHandler::iniRememberPlacement = "RememberPlacement";
const AnsiString TViewHandler::iniRight = "Right";
const AnsiString TViewHandler::iniShowStatusBar = "ShowStatusBar";
const AnsiString TViewHandler::iniShowToolbar = "ShowToolbar";
const AnsiString TViewHandler::iniState = "State";
const AnsiString TViewHandler::iniTop = "Top";
const AnsiString TViewHandler::iniWidth = "Width";
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByDirectory(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByDirectory(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByOldPath(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByOldPath(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByOldName(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByOldName(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByNewPath(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByOldName(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByNewName(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByNewName(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByType(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByType(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
int __fastcall TViewHandler::CompareByResult(TListViewModel* AControl, int AIndex1, int AIndex2)
{
	return TItemUtils::CompareByResult(
		static_cast<TRenameItem*>(AControl->Items[AIndex1]->Value),
		static_cast<TRenameItem*>(AControl->Items[AIndex2]->Value));
}
//---------------------------------------------------------------------------
bool __fastcall TViewHandler::GetShowToolbar()
{
	return Toolbar->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SetShowToolbar(bool AShowToolbar)
{
	Toolbar->Visible = AShowToolbar;
}
//---------------------------------------------------------------------------
bool __fastcall TViewHandler::GetShowStatusBar()
{
	return StatusBar->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SetShowStatusBar(bool AShowStatusBar)
{
	StatusBar->Visible = AShowStatusBar;
}
//---------------------------------------------------------------------------
__fastcall TViewHandler::TViewHandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems) :
	THandler(AControl, AInvoker, AItems),
	FForm(NULL),
	FToolbar(NULL),
	FStatusBar(NULL),
	FListView(NULL),
	FShowToolbar(true),
	FShowStatusBar(true),
	FRememberPlacement(true)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewHandler::~TViewHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::AdjustListColumns()
{
	int LColumnWidth = ListView->ClientWidth / (ListView->Columns->Count + 1);
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		if(LI == 0) {
			ListView->Column[LI]->Width = LColumnWidth * 2;
		}
		else {
			ListView->Column[LI]->Width = LColumnWidth;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByDirectory()
{
	Control->Update(true);
	Control->Sort(CompareByDirectory);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByOldPath()
{
	Control->Update(true);
	Control->Sort(CompareByOldPath);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByOldName()
{
	Control->Update(true);
	Control->Sort(CompareByOldName);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByNewPath()
{
	Control->Update(true);
	Control->Sort(CompareByNewPath);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByNewName()
{
	Control->Update(true);
	Control->Sort(CompareByNewName);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByType()
{
	Control->Update(true);
	Control->Sort(CompareByType);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SortByResult()
{
	Control->Update(true);
	Control->Sort(CompareByResult);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::Invert()
{
	Control->Update(true);
	Control->Invert();
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::MoveUp()
{
	Control->Update(true);
	Control->MoveSelected(-1);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::MoveDown()
{
	Control->Update(true);
	Control->MoveSelected(1);
	Control->UpdateControl(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::LoadSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	ShowToolbar = AFile->ReadBool(
		ASection->Section,
		iniShowToolbar,
		ShowToolbar);
	ShowStatusBar = AFile->ReadBool(
		ASection->Section,
		iniShowStatusBar,
		ShowStatusBar);
	RememberPlacement = AFile->ReadBool(
		ASection->Section,
		iniRememberPlacement,
		RememberPlacement);

	if(RememberPlacement) {
		ASection->Enter(iniForm);
		ASection->Enter(iniBounds);
		TTopLevelWindow(Form->Handle).NormalBounds = TRect(
			AFile->ReadInteger(ASection->Section, iniLeft, TTopLevelWindow(Form->Handle).NormalBounds.left),
			AFile->ReadInteger(ASection->Section, iniTop, TTopLevelWindow(Form->Handle).NormalBounds.top),
			AFile->ReadInteger(ASection->Section, iniRight, TTopLevelWindow(Form->Handle).NormalBounds.right),
			AFile->ReadInteger(ASection->Section, iniBottom, TTopLevelWindow(Form->Handle).Bounds.bottom));
		ASection->Leave();
		TTopLevelWindow(Form->Handle).State = AFile->ReadInteger(ASection->Section, iniState, TTopLevelWindow(Form->Handle).State);
		ASection->Leave();

		ASection->Enter(iniListView);
		ASection->Enter(iniColumn);
		for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
			ASection->Enter(LI);
			ListView->Column[LI]->Width = AFile->ReadInteger(ASection->Section, iniWidth, ListView->Column[LI]->Width);
			ASection->Leave();
		}
		ASection->Leave();
		ASection->Leave();
	}
}
//---------------------------------------------------------------------------
void __fastcall TViewHandler::SaveSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	AFile->WriteBool(
		ASection->Section,
		iniShowToolbar,
		ShowToolbar);
	AFile->WriteBool(
		ASection->Section,
		iniShowStatusBar,
		ShowStatusBar);
	AFile->WriteBool(
		ASection->Section,
		iniRememberPlacement,
		RememberPlacement);

	ASection->Enter(iniForm);
	ASection->Enter(iniBounds);
	AFile->WriteInteger(ASection->Section, iniLeft, TTopLevelWindow(Form->Handle).NormalBounds.left);
	AFile->WriteInteger(ASection->Section, iniTop, TTopLevelWindow(Form->Handle).NormalBounds.top);
	AFile->WriteInteger(ASection->Section, iniRight, TTopLevelWindow(Form->Handle).NormalBounds.right);
	AFile->WriteInteger(ASection->Section, iniBottom, TTopLevelWindow(Form->Handle).NormalBounds.bottom);
	ASection->Leave();
	AFile->WriteInteger(ASection->Section, iniState, TTopLevelWindow(Form->Handle).State);
	ASection->Leave();

	ASection->Enter(iniListView);
	ASection->Enter(iniColumn);
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		ASection->Enter(LI);
		AFile->WriteInteger(ASection->Section, iniWidth, ListView->Column[LI]->Width);
		ASection->Leave();
	}
	ASection->Leave();
	ASection->Leave();
}
//---------------------------------------------------------------------------
} // End namespace Oren_viewhandler
//---------------------------------------------------------------------------

