//---------------------------------------------------------------------------
#ifndef Oren_ViewHandlerH
#define Oren_ViewHandlerH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Oren_Handler.h"
#include "Oren_Rename.h"
//---------------------------------------------------------------------------
namespace Oren_viewhandler {
//---------------------------------------------------------------------------
class TViewHandler : public THandler
{
private:
	static const AnsiString iniBottom;
	static const AnsiString iniBounds;
	static const AnsiString iniColumn;
	static const AnsiString iniForm;
	static const AnsiString iniLeft;
	static const AnsiString iniListView;
	static const AnsiString iniMainForm;
	static const AnsiString iniRememberPlacement;
	static const AnsiString iniRight;
	static const AnsiString iniShowStatusBar;
	static const AnsiString iniShowToolbar;
	static const AnsiString iniState;
	static const AnsiString iniTop;
	static const AnsiString iniWidth;
	TForm* FForm;
	TToolBar* FToolbar;
	TStatusBar* FStatusBar;
	TListView* FListView;
	bool FShowToolbar;
	bool FShowStatusBar;
	bool FRememberPlacement;
	int __fastcall CompareByDirectory(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByOldPath(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByOldName(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByNewPath(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByNewName(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByType(TListViewModel* AControl, int AIndex1, int AIndex2);
	int __fastcall CompareByResult(TListViewModel* AControl, int AIndex1, int AIndex2);
	bool __fastcall GetShowToolbar();
	void __fastcall SetShowToolbar(bool AShowToolbar);
	bool __fastcall GetShowStatusBar();
	void __fastcall SetShowStatusBar(bool AShowStatusBar);
protected:
public:
	__fastcall TViewHandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems);
	virtual __fastcall ~TViewHandler();
	void __fastcall AdjustListColumns();
	void __fastcall SortByDirectory();
	void __fastcall SortByOldPath();
	void __fastcall SortByOldName();
	void __fastcall SortByNewPath();
	void __fastcall SortByNewName();
	void __fastcall SortByType();
	void __fastcall SortByResult();
	void __fastcall Invert();
	void __fastcall MoveUp();
	void __fastcall MoveDown();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile, TIniSection* ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile, TIniSection* ASection);
	__property TForm* Form = {read=FForm, write=FForm};
	__property TToolBar* Toolbar = {read=FToolbar, write=FToolbar};
	__property TStatusBar* StatusBar = {read=FStatusBar, write=FStatusBar};
	__property TListView* ListView = {read=FListView, write=FListView};
	__property bool ShowToolbar = {read=GetShowToolbar, write=SetShowToolbar};
	__property bool ShowStatusBar = {read=GetShowStatusBar, write=SetShowStatusBar};
	__property bool RememberPlacement = {read=FRememberPlacement, write=FRememberPlacement};
};
//---------------------------------------------------------------------------
} // End namespace Oren_viewhandler
using namespace Oren_viewhandler;
//---------------------------------------------------------------------------
#endif

